import playground65

code = """
        ORG  $2000

RES_ATASCII:
        DB $00, $00, $00, $00, $00, $00, $00, $00
RES_BCD:
        DB $00, $00, $00, $00
VAL:    DB $00, $40, $04

; Convert an 16 bit binary value into a 24bit BCD value
BIN2BCD:
        LDA #0          ;Clear the result area
        STA RES_BCD+0
        STA RES_BCD+1
        STA RES_BCD+2
        STA RES_BCD+3
        LDX #24         ;Setup the bit counter
        SED             ;Enter decimal mode
_LOOP:  ASL VAL+0       ;Shift a bit out of the binary
        ROL VAL+1
        ROL VAL+2       ;... value
        LDA RES_BCD+0       ;And add it into the result, doubling
        ADC RES_BCD+0       ;... it at the same time
        STA RES_BCD+0
        LDA RES_BCD+1
        ADC RES_BCD+1
        STA RES_BCD+1
        LDA RES_BCD+2
        ADC RES_BCD+2
        STA RES_BCD+2
        LDA RES_BCD+3
        ADC RES_BCD+3
        STA RES_BCD+3
        DEX             ;More bits to process?
        BNE _LOOP
        CLD             ;Leave decimal mode
        ;BRK
BCD2ATASCII:
        LDX #4
        LDY #0
_LOOP2:
        LDA RES_BCD-1,X
        LSR
        LSR
        LSR
        LSR
        ORA #$30
        STA RES_ATASCII,Y
        LDA RES_BCD-1,X
        AND #$0F
        ORA #$30
        STA RES_ATASCII+1,Y
        INY
        INY
        DEX
        BNE _LOOP2
        BRK
"""

p65=playground65.Playground65()
asm=p65.assemble(code)

p65.until_brk("BIN2BCD")

for l in asm:
  print(l)

print("VAL: " + p65.dump("RES_BCD", 3))
print("RES_BCD: " + p65.dump("RES_BCD", 4))
print("RES_ATASCII: " + p65.dump("RES_ATASCII", 8))
