import sys
from asm6502 import asm6502
from py65emu.cpu import CPU
from py65emu.mmu import MMU


class Playground65:

  def __init__(self):
     self.mmu = MMU([(0x0000, 0x10000)])
     self.cpu = CPU(self.mmu, 0x200)
  
  def assemble(self, code, debug=0):
    self.asm6502 = asm6502(debug) 

    lines = code.splitlines()
    assembled = self.asm6502.assemble(lines)

    for i in range(0x10000):
      self.mmu.write(i, self.asm6502.object_code[i])

    return assembled[0]

  def dump(self, addr=0, size=1):
    if addr in self.asm6502.symbols: addr=self.asm6502.symbols[addr] # nice dynamic languaje
    
    ret=""
    for i in range(size):
      ret+=("%02x" % (self.mmu.read(addr+i))) + ("\n" if i&15==15 else " ")
    return ret

  def until_brk(self, addr):
    if addr in self.asm6502.symbols: addr=self.asm6502.symbols[addr] # nice dynamic languaje
    self.cpu.r.pc=addr
    while self.mmu.read(self.cpu.r.pc)!=0x00:
      self.cpu.step()
    
